<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/22/2005 *
 * ===============                              Last change: 11/22/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : bonus_mails.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Sends out reminder mails                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Versendet Erinnerungsmails                       *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!EXT_IS_ACTIVE("bonus")) {
	return;
}

// Do not execute when script is in CSS mode
global $CSS;
if ($CSS == 1) return;

// Create timemark from saved month
$mark = mktime(0, 0, 0, getConfig('last_month'), date("d", time()), date('Y', time()));
$SQL = ""; $MODE = "";

// Shall I sent activation or deactivation mail?
$SQL = "SELECT userid, email FROM `"._MYSQL_PREFIX."_user_data` WHERE (bonus_ral_notify ";
switch (getConfig('bonus_active'))
{
case "Y": // Active rallye is activated
	if (getConfig('bonus_en_notify') == "Y") {
		// Okay, let's check for member accounts
		$SQL .= "= 0 OR (bonus_ral_notify > 0 AND bonus_ral_en_notify < bonus_ral_di_notify)";
		$MODE = "en";
	} else {
		// Do not notify!
		$SQL = "";
	}
	break;

case "N": // Active rallye is deactivated
	if (getConfig('bonus_di_notify') == "Y") {
		// Okay, let's check for member accounts
		$SQL .= " > 0 AND bonus_ral_di_notify < bonus_ral_en_notify";
		$MODE = "di";
	} else {
		// Do not notify!
		$SQL = "";
	}
	break;
}

if (!empty($SQL)) {
	// The SQL command needs to be finisched here (only confirmed accounts!)
	$SQL .= ") AND status='CONFIRMED' ORDER BY last_online ASC";

	// Normal notification mails or bonus mails?
	$MAIL_MODE = ((getConfig('bonus_notify_points') > 0) && ($MODE == "en") && (EXT_IS_ACTIVE("bonus")));

	// Generate subject line
	$SUBJECT = constant('BONUS_RALLYE_'.strtoupper($MODE).'_NOTIFY');

	// Load message body for bonus mails
	$MSG = LOAD_EMAIL_TEMPLATE("bonus_en_notify_body", "", "{PER}uid{PER}");
	$RECEIVER = ""; $UIDs = array();

	// Check for accounts to be notified
	$result_main = SQL_QUERY($SQL, __FILE__, __LINE__);
	if (SQL_NUMROWS($result_main) > 0) {
		// Okay lets notify all users!
		while(list($uid, $email) = SQL_FETCHROW($result_main)) {
			// Update account
			SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_user_data
SET bonus_ral_notify='%s', bonus_ral_%s_notify='%s'
WHERE userid=%s
LIMIT 1",
				array(time(), $MODE, time(), $uid), __FILE__, __LINE__);

			// Load email template and send it to the user!
			if ($MAIL_MODE) {
				// Add userid to queue
				$UIDs[] = $uid;
			} else {
				// Send normal notification mail to the members
				$MSG = LOAD_EMAIL_TEMPLATE("bonus_".$MODE."_notify", array(), $uid);
				SEND_EMAIL($uid, $SUBJECT, $MSG);
			}
		} // END - while

		// Shall I send out bonus mails?
		if ($MAIL_MODE) {
			// Okay, make array to string
			$RECEIVER = implode(";", $UIDs);

			// Prepare URL
			$url = URL."/modules.php?module=index&what=login";

			// Insert mail
			ADD_BONUS_MAIL_TO_QUEUE($SUBJECT, $MSG, $RECEIVER, getConfig('bonus_notify_points'), getConfig('bonus_notify_wait'), $url, 0, "normal", SQL_NUMROWS($result_main));
		} // END - if
	} // END - if

	// Free memory
	SQL_FREERESULT($result_main);
} // END - if

//
?>
